<?php
namespace Teknisa\CADFIN\Controllers;

use Teknisa\CADFIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CADFIN\Services\Ger08300BancoService;
use Zeedhi\Framework\DTO\Response\Error;

class Ger08300BancoController extends TeknisaCrud{
    protected $dataSourceName = 'banco';
    protected $environment;
     
    public function __construct($crudService, $parameterBag,  $service, $environment) {
        $this->service = $service;
        $this->environment   = $environment;
        parent::__construct($crudService, $parameterBag);
    }

    public function buscaBancos(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
        $row = array();
        if(isset($conditions[0])) {
            if($conditions[0]['columnName'] === 'CDBANCO') {
                $row['CDBANCO'] = $conditions[0]['value'];
                if(isset($conditions[1])) {
                    $row['NMBANCO'] = $conditions[1]['value'];
                }
            }
            else {
                $row['NMBANCO'] = $conditions[0]['value'];
                 if(isset($conditions[1])) {
                    $row['CDBANCO'] = $conditions[1]['value'];
                }
            }
        }
        else {
            $row['CDBANCO'] = NULL;
            $row['NMBANCO'] = NULL;
        }
        $result = $this->service->buscaBancos($row);
        $dataSet = new DataSet('buscaBancos', $result);
        $response->addDataSet($dataSet);
   	}
   	
   	public function save(DTO\Request $request, DTO\Response $response) {
       	 try{
       	    $NRORG0 = false;
            $row = $request->getDataSet()->getRows()[0];
            
            if(!isset($row['__is_new']))
                $row['__is_new'] = false;
            if(!isset($row['NRORG']))
                 $row['NRORG'] = $this->environment->getNrOrgTrab();
            
            
       	    if($row['__is_new'] === false) {
       	        $rows = array($row);
       	        if($row['NRORG'] === 0) {
           	        $this->service->getRowUpdate($row);
        		    $this->crudService->save($this->dataSourceName, $rows);
                    $response->addDataSet(new DataSet("columnsToReturn", $this->crudService->getColumnsToReturn()));
       	        }
       	        else {
       	            $rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
       	            $this->crudService->save($this->dataSourceName, $rows);
                    $response->addDataSet(new DataSet("columnsToReturn", $this->crudService->getColumnsToReturn()));
       	        }
       	    }
       	    else {
       	        parent::save($request, $response);
       	    }
       	 }
   	    catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
   	}
}